Attribute VB_Name = "Module_Function"
Option Explicit

' -----------------------------------------------------------------------------
' This file will be used to create general FUNCTIONS
' -----------------------------------------------------------------------------

Public Sub Save2bytes(offset, value, Location)
' -----------------------------------------------------------------------------
' Function called to save 2 Bytes, i.e. HP
' -----------------------------------------------------------------------------
    Dim sval As Byte
    Dim A, B, C
    
    value = (value Mod &H10000)
    
    A = Hex(value)
    If Len(A) = 1 Then A = "000" & A
    If Len(A) = 2 Then A = "00" & A
    If Len(A) = 3 Then A = "0" & A
    
    B = ConvertHex(Left(A, 2))
    C = ConvertHex(Right(A, 2))
    
    Put #1, offset, CByte(C)
    Put #1, offset - -1, CByte(B)
    
End Sub

Public Sub Save3bytes(offset, value, Location)
' -----------------------------------------------------------------------------
' Function called to save 3 Bytes, i.e. Experience
' -----------------------------------------------------------------------------

    Dim sval As Byte
    Dim A, B, C, D
    
    value = (value Mod &H1000000)
    
    A = Hex(value)
    If Len(A) = 1 Then A = "00000" & A
    If Len(A) = 2 Then A = "0000" & A
    If Len(A) = 3 Then A = "000" & A
    If Len(A) = 4 Then A = "00" & A
    If Len(A) = 5 Then A = "0" & A
    
    B = ConvertHex(Left(A, 2))
    C = ConvertHex(Right(A, 4)) \ 256
    D = ConvertHex(Right(A, 2))
    
    Put #1, offset, CByte(D)
    Put #1, offset - -1, CByte(C)
    Put #1, offset - -2, CByte(B)
    
End Sub

Function ConvertHex(h$) As Currency
    Dim Tmp$
    Dim lo1 As Integer, lo2 As Integer
    Dim hi1 As Long, hi2 As Long
    Const Hx = "&H"
    Const BigShift = 65536
    Const LilShift = 256, Two = 2
    
    Tmp = h
    'In case "&H" is present
    
    If UCase(Left$(h, 2)) = "&H" Then Tmp = Mid$(h, 3)
    'In case there are too few characters
    
    Tmp = Right$("0000000" & Tmp, 8)
    'In case it wasn't a valid number
    
    If IsNumeric(Hx & Tmp) Then
        lo1 = CInt(Hx & Right$(Tmp, Two))
        hi1 = CLng(Hx & Mid$(Tmp, 5, Two))
        lo2 = CInt(Hx & Mid$(Tmp, 3, Two))
        hi2 = CLng(Hx & Left$(Tmp, Two))
        ConvertHex = CCur(hi2 * LilShift + lo2) * BigShift + (hi1 * LilShift) + lo1
    End If
    
End Function
