VERSION 5.00
Begin VB.Form form_World_Inventory 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Inventory"
   ClientHeight    =   5580
   ClientLeft      =   45
   ClientTop       =   735
   ClientWidth     =   3165
   Icon            =   "form_World_Inventory.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5580
   ScaleWidth      =   3165
   StartUpPosition =   1  'CenterOwner
   Begin VB.ListBox ListInventory 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3765
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   2895
   End
   Begin VB.ComboBox cbName 
      Height          =   315
      Left            =   1080
      TabIndex        =   2
      Text            =   "cbName"
      Top             =   4200
      Width           =   1935
   End
   Begin VB.ComboBox cbQuantity 
      Height          =   315
      Left            =   1080
      TabIndex        =   1
      Text            =   "cbQuantity"
      Top             =   4560
      Width           =   1935
   End
   Begin VB.CommandButton buttonUpdate 
      Caption         =   "&Update"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   5040
      Width           =   1455
   End
   Begin VB.Label LabelName 
      AutoSize        =   -1  'True
      Caption         =   "Name: "
      Height          =   195
      Left            =   240
      TabIndex        =   5
      Top             =   4200
      Width           =   510
   End
   Begin VB.Label LabelQuantity 
      AutoSize        =   -1  'True
      Caption         =   "Quantity:"
      Height          =   195
      Left            =   240
      TabIndex        =   4
      Top             =   4560
      Width           =   630
   End
   Begin VB.Menu menu_File 
      Caption         =   "&File"
      Begin VB.Menu menu_Save 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu menu_Dump 
         Caption         =   "&Dump"
         Shortcut        =   ^D
      End
      Begin VB.Menu menu_Exit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu menu_Max 
      Caption         =   "&Max"
      Begin VB.Menu menu_Max_Items 
         Caption         =   "Max Items"
      End
   End
End
Attribute VB_Name = "form_World_Inventory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit                 ' Forces to declare all variables used
Option Base 0                   ' Stuff starts in 0

Dim CurVal As Byte              ' Stores current value loaded from the game
Dim FF As Long                  ' Channel used to modify the file loaded
Dim ItemList(255) As Byte       '
Dim QuantityList(255) As Byte   '

Private Sub buttonUpdate_Click()
' -----------------------------------------------------------------------------
' Updates the list
' -----------------------------------------------------------------------------
    Call UpdateList

End Sub

Private Sub Form_Load()
' -----------------------------------------------------------------------------
' STARTING PROPERTIES
' -----------------------------------------------------------------------------
    AddItemToComboBox cbName
    AddNumberToComboBox cbQuantity
    
    Call LoadInventory(form_Main.CD_Load_File.FileName)
    ListInventory.ListIndex = 0

End Sub

Public Sub LoadInventory(pFile As String)
' -----------------------------------------------------------------------------
' Loads the Inventory
' -----------------------------------------------------------------------------

    Dim i As Integer

    ' The variable FF is equal to the next available file number
    FF = FreeFile
    
    Open pFile For Binary As #FF
    
        ' ==================================================
        ' LOAD THE INVENTORY
        ' ==================================================
        ' ==================================================
        ' LOAD THE ID & QUANTITY
        ' ==================================================
        For i = 0 To 255
            Get #FF, &H1253 + 1 + (i), CurVal
                ItemList(i) = CurVal
            Get #FF, &H1353 + 1 + (i), CurVal
                QuantityList(i) = CurVal
        Next i
        
        Call LoadList
        
    Close #FF

End Sub

Private Sub Form_Unload(Cancel As Integer)
' -----------------------------------------------------------------------------
' Unload the window
' -----------------------------------------------------------------------------
    form_Main.Show

End Sub

Public Sub LoadList()
' -----------------------------------------------------------------------------
' Populates the List
' -----------------------------------------------------------------------------
    Dim i As Integer
    
    ListInventory.Clear
    
    For i = 0 To 255
        ListInventory.AddItem cbName.List(ItemList(i)) & Space(18 - Len(cbName.List(ItemList(i)))) & QuantityList(i)
    Next i
    
End Sub


Public Sub AddItemToComboBox(pCombobox As ComboBox)
' -----------------------------------------------------------------------------
' Populates the ITEMS on the Combobox
' -----------------------------------------------------------------------------
    Dim i As Integer

    For i = 0 To 255
        pCombobox.AddItem Items.Item(i + 1)
    Next i
    
    pCombobox.Text = pCombobox.List(0)

End Sub

Public Sub AddNumberToComboBox(pCombobox As ComboBox)
' -----------------------------------------------------------------------------
' Populates the QUANTITY on the Combobox
' -----------------------------------------------------------------------------
    Dim i As Integer

    For i = 0 To 255
        pCombobox.AddItem (i)
    Next i
    
    pCombobox.Text = pCombobox.List(0)

End Sub

Private Sub ListInventory_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    cbName.ListIndex = ItemList(ListInventory.ListIndex)
    cbQuantity.ListIndex = QuantityList(ListInventory.ListIndex)

End Sub

Private Sub menu_Dump_Click()
' -----------------------------------------------------------------------------
' Menu->File->Dump
' -----------------------------------------------------------------------------
    Dim i As Integer
    
    ' Change the mouse pointer to an hourglass
    Screen.MousePointer = vbHourglass

    ' Open Save File box
    form_Main.CD_Save_File.ShowSave
    
    If form_Main.CD_Save_File.FileName = "" Then Exit Sub
    
    ' Create a txt file output
    Open form_Main.CD_Save_File.FileName For Output As #1
    
        Print #1, "----------------------"
        Print #1, "      INVENTORY       "
        Print #1, "----------------------"
        Print #1, ""

        For i = 0 To 255
            Print #1, Space(17 - Len(cbName.List(ItemList(i)))) & cbName.List(ItemList(i)) & ": " & QuantityList(i)
        Next i
        
    Close #1
    
    ' Change the mouse pointer back to its default
    Screen.MousePointer = vbDefault
    
    ' User Notification
    MsgBox "The text file has been generated", vbOKOnly, App.ProductName
        
End Sub

Private Sub menu_Exit_Click()
' -----------------------------------------------------------------------------
' Menu File->Exit
' -----------------------------------------------------------------------------
    form_World_Inventory.Hide
    form_Main.Show

End Sub

Private Sub menu_Max_Items_Click()
' -----------------------------------------------------------------------------
' Menu File->Max Items
' -----------------------------------------------------------------------------
    Call MaxItemList(form_Main.CD_Load_File.FileName)
    
    ' User notification
    MsgBox "99 of every item has been given", vbOKOnly, App.ProductName
    
    Call LoadInventory(form_Main.CD_Load_File.FileName)

End Sub

Private Sub menu_Save_Click()
' -----------------------------------------------------------------------------
' Menu File->Save
' -----------------------------------------------------------------------------
    Call SaveFile(form_Main.CD_Load_File.FileName)
    
    ' User notification
    MsgBox "The inventory has been saved", vbOKOnly, App.ProductName

End Sub

Public Sub SaveFile(pFile As String)
' -----------------------------------------------------------------------------
' Saves the file
' -----------------------------------------------------------------------------
    Dim i As Integer

    FF = FreeFile
    
    Open pFile For Binary As #FF
    
    ' ==================================================
    ' SAVE THE LIST
    ' ==================================================
        For i = 0 To 255
            Put #FF, &H1253 + 1 + (i), CByte(ItemList(i))
                ItemList(i) = CurVal
            Put #FF, &H1353 + 1 + (i), CByte(QuantityList(i))
                QuantityList(i) = CurVal
        Next i
    
    Close #FF

End Sub

Public Sub MaxItemList(pFile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim i As Integer
    
    ' Get the next available file number
    FF = FreeFile
    
    Open pFile For Binary As #FF
    
    ' ==================================================
    ' SAVE 99 OF EACH ITEM
    ' ==================================================
    
        For i = 0 To 255
            Put #FF, &H1253 + 1 + i, CByte(i)       ' ID
            Put #FF, &H1353 + 1 + i, CByte(99)      ' Quantity
        Next i
    
    Close #FF
    
End Sub

Public Sub UpdateList()
' -----------------------------------------------------------------------------
' Refreshes the list
' -----------------------------------------------------------------------------
    Dim position As Integer
    
    ItemList(ListInventory.ListIndex) = cbName.ListIndex
    QuantityList(ListInventory.ListIndex) = cbQuantity.ListIndex
    
    position = ListInventory.ListIndex
    
    Call LoadList
    ListInventory.ListIndex = position

End Sub
